Index: /palm/trunk/SOURCE/lpm_exchange_horiz.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_exchange_horiz.f90	(revision 1319)
+++ /palm/trunk/SOURCE/lpm_exchange_horiz.f90	(revision 1320)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! ------------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -45,23 +49,64 @@
 !------------------------------------------------------------------------------!
 
-    USE control_parameters
-    USE cpulog
-    USE grid_variables
-    USE indices
-    USE particle_attributes
+    USE control_parameters,                                                    &
+        ONLY:  message_string, netcdf_output, netcdf_data_format
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point_s
+
+    USE grid_variables,                                                        &
+        ONLY:  ddx, ddy, dx, dy
+
+    USE indices,                                                               &
+        ONLY:  nx, nxl, nxr, ny, nyn, nys
+
+    USE kinds
+
+    USE particle_attributes,                                                   &
+        ONLY:  deleted_particles, deleted_tails, ibc_par_lr, ibc_par_ns,       &
+               maximum_number_of_particles, maximum_number_of_tails,           &
+               maximum_number_of_tailpoints, mpi_particle_type,                &
+               number_of_tails, number_of_particles, particles, particle_mask, &
+               particle_tail_coordinates, particle_type, tail_mask,            &
+               trlp_count_sum, trlp_count_recv_sum, trnp_count_sum,            &
+               trnp_count_recv_sum, trrp_count_sum, trrp_count_recv_sum,       &
+               trsp_count_sum, trsp_count_recv_sum, use_particle_tails
+
     USE pegrid
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, n, nn, tlength, &
-                trlp_count, trlp_count_recv, trlpt_count, trlpt_count_recv, &
-                trnp_count, trnp_count_recv, trnpt_count, trnpt_count_recv, &
-                trrp_count, trrp_count_recv, trrpt_count, trrpt_count_recv, &
-                trsp_count, trsp_count_recv, trspt_count, trspt_count_recv
-
-    REAL, DIMENSION(:,:,:), ALLOCATABLE ::  trlpt, trnpt, trrpt, trspt
-
-    TYPE(particle_type), DIMENSION(:), ALLOCATABLE ::  trlp, trnp, trrp, trsp
-
+    INTEGER(iwp) ::  i                                       !:
+    INTEGER(iwp) ::  j                                       !:
+    INTEGER(iwp) ::  n                                       !:
+    INTEGER(iwp) ::  nn                                      !:
+    INTEGER(iwp) ::  tlength                                 !:
+    INTEGER(iwp) ::  trlp_count                              !:
+    INTEGER(iwp) ::  trlp_count_recv                         !:
+    INTEGER(iwp) ::  trlpt_count                             !:
+    INTEGER(iwp) ::  trlpt_count_recv                        !:
+    INTEGER(iwp) ::  trnp_count                              !:
+    INTEGER(iwp) ::  trnp_count_recv                         !:
+    INTEGER(iwp) ::  trnpt_count                             !:
+    INTEGER(iwp) ::  trnpt_count_recv                        !:
+    INTEGER(iwp) ::  trrp_count                              !:
+    INTEGER(iwp) ::  trrp_count_recv                         !:
+    INTEGER(iwp) ::  trrpt_count                             !:
+    INTEGER(iwp) ::  trrpt_count_recv                        !:
+    INTEGER(iwp) ::  trsp_count                              !:
+    INTEGER(iwp) ::  trsp_count_recv                         !:
+    INTEGER(iwp) ::  trspt_count                             !:
+    INTEGER(iwp) ::  trspt_count_recv                        !:
+
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  trlpt        !:
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  trnpt        !:
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  trrpt        !:
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  trspt        !:
+
+
+    TYPE(particle_type), DIMENSION(:), ALLOCATABLE ::  trlp  !:
+    TYPE(particle_type), DIMENSION(:), ALLOCATABLE ::  trnp  !:
+    TYPE(particle_type), DIMENSION(:), ALLOCATABLE ::  trrp  !:
+    TYPE(particle_type), DIMENSION(:), ALLOCATABLE ::  trsp  !:
 
 #if defined( __parallel )
Index: /palm/trunk/SOURCE/lpm_extend_particle_array.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_extend_particle_array.f90	(revision 1319)
+++ /palm/trunk/SOURCE/lpm_extend_particle_array.f90	(revision 1320)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! ------------------
-! 
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -38,13 +42,20 @@
 !------------------------------------------------------------------------------!
 
-    USE particle_attributes
+    USE kinds
+
+    USE particle_attributes,                                                   &
+        ONLY:  number_of_initial_particles, number_of_particles,               &
+               maximum_number_of_particles, particles, particle_mask,          &
+               particle_type, write_particle_statistics
 
     IMPLICIT NONE
 
-    INTEGER ::  new_maximum_number, number_of_new_particles
+    INTEGER(iwp) ::  new_maximum_number                              !:
+    INTEGER(iwp) ::  number_of_new_particles                         !:
 
-    LOGICAL, DIMENSION(:), ALLOCATABLE ::  tmp_particle_mask
 
-    TYPE(particle_type), DIMENSION(:), ALLOCATABLE ::  tmp_particles
+    LOGICAL, DIMENSION(:), ALLOCATABLE ::  tmp_particle_mask         !:
+
+    TYPE(particle_type), DIMENSION(:), ALLOCATABLE ::  tmp_particles !:
 
 
Index: /palm/trunk/SOURCE/lpm_extend_tail_array.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_extend_tail_array.f90	(revision 1319)
+++ /palm/trunk/SOURCE/lpm_extend_tail_array.f90	(revision 1320)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! ------------------
-! 
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -38,14 +42,20 @@
 !------------------------------------------------------------------------------!
 
-    USE particle_attributes
+    USE kinds
+
+    USE particle_attributes,                                                   &
+        ONLY:  maximum_number_of_tails, maximum_number_of_tailpoints,          &
+               new_tail_id, number_of_initial_tails, number_of_tails,          &
+               particle_tail_coordinates, tail_mask, write_particle_statistics
 
     IMPLICIT NONE
 
-    INTEGER ::  new_maximum_number, number_of_new_tails
+    INTEGER(iwp) ::  new_maximum_number                           !:
+    INTEGER(iwp) ::  number_of_new_tails                          !:
 
-    LOGICAL, DIMENSION(maximum_number_of_tails) ::  tmp_tail_mask
+    LOGICAL, DIMENSION(maximum_number_of_tails) ::  tmp_tail_mask !:
 
-    REAL, DIMENSION(maximum_number_of_tailpoints,5,maximum_number_of_tails) :: &
-                                                    tmp_tail
+    REAL(wp), DIMENSION(maximum_number_of_tailpoints,5,maximum_number_of_tails) :: &
+                                                    tmp_tail      !:
 
 
Index: /palm/trunk/SOURCE/lpm_extend_tails.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_extend_tails.f90	(revision 1319)
+++ /palm/trunk/SOURCE/lpm_extend_tails.f90	(revision 1320)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! ------------------
-! 
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -38,12 +42,21 @@
 !------------------------------------------------------------------------------!
 
-    USE control_parameters
-    USE particle_attributes
+    USE control_parameters,                                                    &
+        ONLY:  dt_3d
+
+    USE kinds
+
+    USE particle_attributes,                                                   &
+        ONLY:  maximum_number_of_tailpoints, maximum_tailpoint_age,            &
+               minimum_tailpoint_distance, number_of_particles, particles,     &
+               particle_tail_coordinates
 
     IMPLICIT NONE
 
-    INTEGER ::  i, n, nn
+    INTEGER(iwp) ::  i       !:
+    INTEGER(iwp) ::  n       !:
+    INTEGER(iwp) ::  nn      !:
 
-    REAL ::  distance
+    REAL(wp) ::  distance    !:
 
 
Index: /palm/trunk/SOURCE/lpm_init.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_init.f90	(revision 1319)
+++ /palm/trunk/SOURCE/lpm_init.f90	(revision 1320)
@@ -20,4 +20,11 @@
 ! Current revisions:
 ! -----------------
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
+! bugfix: #if defined( __parallel ) added
 !
 ! Former revisions:
@@ -52,41 +59,4 @@
 ! of arrays.
 !
-! 622 2010-12-10 08:08:13Z raasch
-! optional barriers included in order to speed up collective operations
-!
-! 336 2009-06-10 11:19:35Z raasch
-! Maximum number of tails is calculated from maximum number of particles and
-! skip_particles_for_tail,
-! output of messages replaced by message handling routine
-! Bugfix: arrays for tails are allocated with a minimum size of 10 tails if
-! there is no tail initially
-!
-! 150 2008-02-29 08:19:58Z raasch
-! Setting offset_ocean_* needed for calculating vertical indices within ocean
-! runs
-!
-! 117 2007-10-11 03:27:59Z raasch
-! Sorting of particles only in case of cloud droplets
-!
-! 106 2007-08-16 14:30:26Z raasch
-! variable iran replaced by iran_part
-!
-! 82 2007-04-16 15:40:52Z raasch
-! Preprocessor directives for old systems removed
-!
-! 70 2007-03-18 23:46:30Z raasch
-! displacements for mpi_particle_type changed, age_m initialized,
-! particles-package is now part of the default code
-!
-! 16 2007-02-15 13:16:47Z raasch
-! Bugfix: MPI_REAL in MPI_ALLREDUCE replaced by MPI_INTEGER
-!
-! r4 | raasch | 2007-02-13 12:33:16 +0100 (Tue, 13 Feb 2007)
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.24  2007/02/11 13:00:17  raasch
-! Bugfix: allocation of tail_mask and new_tail_id in case of restart-runs
-! Bugfix: __ was missing in a cpp-directive
-!
 ! Revision 1.1  1999/11/25 16:22:38  raasch
 ! Initial revision
@@ -99,25 +69,80 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE cloud_parameters
-    USE control_parameters
-    USE dvrp_variables
-    USE grid_variables
-    USE indices
-    USE lpm_collision_kernels_mod
-    USE particle_attributes
+    USE arrays_3d,                                                             &
+        ONLY:  de_dx, de_dy, de_dz, zu, zw, z0
+
+    USE cloud_parameters,                                                      &
+        ONLY:  curvature_solution_effects
+
+    USE control_parameters,                                                    &
+        ONLY:  cloud_droplets, current_timestep_number, initializing_actions,  &
+               message_string, netcdf_output,netcdf_data_format, ocean,        &
+               prandtl_layer, simulated_time
+
+    USE dvrp_variables,                                                        &
+        ONLY:  particle_color, particle_dvrpsize
+
+    USE grid_variables,                                                        &
+        ONLY:  dx, dy
+
+    USE indices,                                                               &
+        ONLY:  nx, nxl, nxlg, nxrg, nxr, ny, nyn, nys, nyng, nysg, nz, nzb, nzt
+
+    USE kinds
+
+    USE lpm_collision_kernels_mod,                                             &
+        ONLY:  init_kernels
+
+    USE particle_attributes,                                                   &
+        ONLY:   bc_par_b, bc_par_lr, bc_par_ns, bc_par_t, collision_kernel,    &
+                density_ratio, dvrp_psize, initial_weighting_factor, ibc_par_b,&
+                ibc_par_lr, ibc_par_ns, ibc_par_t, initial_particles,          &
+                iran_part, log_z_z0, max_number_of_particle_groups,            &
+                maximum_number_of_particles, maximum_number_of_tailpoints,     &
+                minimum_tailpoint_distance, maximum_number_of_tails,           &
+                mpi_particle_type, new_tail_id, number_of_initial_particles,   &
+                number_of_initial_tails, number_of_particles,                  &
+                number_of_particle_groups, number_of_sublayers,                &
+                number_of_tails, offset_ocean_nzt, offset_ocean_nzt_m1, part_1,&
+                part_2, particles, particle_advection_start, particle_groups,  &
+                particle_groups_type, particle_mask, particles_per_point,      &
+                particle_tail_coordinates,  particle_type, pdx, pdy, pdz,      &
+                prt_count, prt_start_index, psb, psl, psn, psr, pss, pst,      &
+                radius, random_start_position, read_particles_from_restartfile,&
+                skip_particles_for_tail, sort_count, tail_mask,                &
+                total_number_of_particles, total_number_of_tails,              &
+                use_particle_tails, use_sgs_for_particles,                     &
+                write_particle_statistics, uniform_particles, z0_av_global
+
     USE pegrid
-    USE random_function_mod
+
+    USE random_function_mod,                                                   &
+        ONLY:  random_function
 
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k, n, nn
+    INTEGER(iwp) ::  i                           !:
+    INTEGER(iwp) ::  j                           !:
+    INTEGER(iwp) ::  k                           !:
+    INTEGER(iwp) ::  n                           !:
+    INTEGER(iwp) ::  nn                          !:
+
 #if defined( __parallel )
-    INTEGER, DIMENSION(3) ::  blocklengths, displacements, types
+    INTEGER(iwp), DIMENSION(3) ::  blocklengths  !:
+    INTEGER(iwp), DIMENSION(3) ::  displacements !:
+    INTEGER(iwp), DIMENSION(3) ::  types         !:
 #endif
-    LOGICAL ::  uniform_particles_l
-    REAL    ::  height_int, height_p, pos_x, pos_y, pos_z, z_p,            &
-                z0_av_local = 0.0
+    LOGICAL ::  uniform_particles_l              !:
+
+    REAL(wp)    ::  height_int                   !:
+    REAL(wp)    ::  height_p                     !:
+    REAL(wp)    ::  pos_x                        !:
+    REAL(wp)    ::  pos_y                        !:
+    REAL(wp)    ::  pos_z                        !:
+    REAL(wp)    ::  z_p                          !:
+    REAL(wp)    ::  z0_av_local = 0.0            !:
+
+                
 
 
@@ -211,6 +236,10 @@
        z0_av_global = 0.0
 
+#if defined( __parallel )
        CALL MPI_ALLREDUCE(z0_av_local, z0_av_global, 1, MPI_REAL, MPI_SUM, &
                           comm2d, ierr )
+#else
+       z0_av_global = z0_av_local
+#endif
 
        z0_av_global = z0_av_global  / ( ( ny + 1 ) * ( nx + 1 ) )
Index: /palm/trunk/SOURCE/lpm_init_sgs_tke.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_init_sgs_tke.f90	(revision 1319)
+++ /palm/trunk/SOURCE/lpm_init_sgs_tke.f90	(revision 1320)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! ------------------
-! 
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -41,15 +45,29 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE control_parameters
-    USE grid_variables
-    USE indices
-    USE particle_attributes
+    USE arrays_3d,                                                             &
+        ONLY:  de_dx, de_dy, de_dz, diss, e, u, v, w, zu
+
+    USE grid_variables,                                                        &
+        ONLY:  ddx, ddy
+
+    USE indices,                                                               &
+        ONLY:  nbgp, ngp_2dh_outer, nx, nxl, nxr, ny, nyn, nys, nz, nzb,       &
+                      nzb_s_inner, nzb_s_outer, nzt
+
+    USE kinds
+
+    USE particle_attributes,                                                   &
+        ONLY:  sgs_wfu_part, sgs_wfv_part, sgs_wfw_part
+
     USE pegrid
-    USE statistics
+
+    USE statistics,                                                            &
+        ONLY:  flow_statistics_called, hom, sums, sums_l
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k
+    INTEGER(iwp) ::  i      !:
+    INTEGER(iwp) ::  j      !:
+    INTEGER(iwp) ::  k      !:
 
 
Index: /palm/trunk/SOURCE/lpm_pack_arrays.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_pack_arrays.f90	(revision 1319)
+++ /palm/trunk/SOURCE/lpm_pack_arrays.f90	(revision 1320)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! ------------------
-! 
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -40,11 +44,17 @@
 !------------------------------------------------------------------------------!
 
-    USE particle_attributes
+    USE kinds
+
+    USE particle_attributes,                                                   &
+        ONLY:  deleted_particles, deleted_tails, new_tail_id,                  &
+               number_of_particles, number_of_tails, particles, particle_mask, &
+               particle_tail_coordinates, tail_mask, use_particle_tails
+
 
     IMPLICIT NONE
 
-    INTEGER ::  n, nd, nn
-
-
+    INTEGER(iwp) ::  n       !:
+    INTEGER(iwp) ::  nd      !:
+    INTEGER(iwp) ::  nn      !:
 !
 !-- Find out elements marked for deletion and move data with higher index
Index: /palm/trunk/SOURCE/lpm_read_restart_file.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_read_restart_file.f90	(revision 1319)
+++ /palm/trunk/SOURCE/lpm_read_restart_file.f90	(revision 1320)
@@ -20,5 +20,7 @@
 ! Current revisions:
 ! ------------------
-! 
+! ONLY-attribute added to USE-statements,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -38,12 +40,27 @@
 !------------------------------------------------------------------------------!
 
-    USE control_parameters
-    USE indices
-    USE particle_attributes
+    USE control_parameters,                                                    &
+        ONLY:  message_string
+
+    USE indices,                                                               &
+        ONLY:  nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nz, nzb, nzt
+
+    USE particle_attributes,                                                   &
+        ONLY:  bc_par_b, bc_par_lr, bc_par_ns, bc_par_t, initial_particles,    &
+               number_of_initial_particles, maximum_number_of_particles,       &
+               maximum_number_of_tailpoints, maximum_number_of_tails,          &
+               new_tail_id, number_of_particles, number_of_particle_groups,    &
+               number_of_tails, particles, particle_groups, particle_mask,     &
+               particle_tail_coordinates, particle_type, part_1, part_2,       &
+               prt_count, prt_start_index,  sort_count, tail_mask, time_prel,  &
+               time_write_particle_data, uniform_particles, use_particle_tails
+
+
     USE pegrid
 
     IMPLICIT NONE
 
-    CHARACTER (LEN=10) ::  particle_binary_version, version_on_file
+    CHARACTER (LEN=10) ::  particle_binary_version    !:
+    CHARACTER (LEN=10) ::  version_on_file            !:
 
 !
Index: /palm/trunk/SOURCE/lpm_release_set.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_release_set.f90	(revision 1319)
+++ /palm/trunk/SOURCE/lpm_release_set.f90	(revision 1320)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! ------------------
-! 
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -40,13 +44,32 @@
 !------------------------------------------------------------------------------!
 
-    USE control_parameters
-    USE grid_variables
-    USE indices
-    USE particle_attributes
-    USE random_function_mod
+    USE control_parameters,                                                    &
+        ONLY:  iran, message_string, netcdf_data_format, netcdf_output
+
+    USE grid_variables,                                                        &
+        ONLY:  dx, dy
+
+    USE indices,                                                               &
+        ONLY:  nxl, nxr, nyn, nys
+
+    USE kinds
+
+    USE particle_attributes,                                                   &
+        ONLY:  initial_particles, iran_part, maximum_number_of_particles,      &
+               maximum_number_of_tails, minimum_tailpoint_distance,            &
+               number_of_initial_particles, number_of_initial_tails,           &
+               number_of_particles, number_of_tails, particles,                &
+               particle_tail_coordinates, pdx, pdy, pdz, psb, psl, psn, psr,   &
+               pss, pst, random_start_position, use_particle_tails
+
+    USE random_function_mod,                                                   &
+        ONLY:  random_function
 
     IMPLICIT NONE
 
-    INTEGER ::  ie, is, n, nn
+    INTEGER(iwp) ::  ie     !:
+    INTEGER(iwp) ::  is     !:
+    INTEGER(iwp) ::  n      !:
+    INTEGER(iwp) ::  nn     !:
 
 
Index: /palm/trunk/SOURCE/lpm_set_attributes.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_set_attributes.f90	(revision 1319)
+++ /palm/trunk/SOURCE/lpm_set_attributes.f90	(revision 1320)
@@ -20,5 +20,10 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -37,7 +42,4 @@
 ! 828 2012-02-21 12:00:36Z raasch
 ! particle feature color renamed class
-!
-! 622 2010-12-10 08:08:13Z raasch
-! optional barriers included in order to speed up collective operations
 !
 ! 271 2009-03-26 00:47:14Z raasch
@@ -50,21 +52,61 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE control_parameters
-    USE cpulog
-    USE dvrp_variables
-    USE grid_variables
-    USE indices
-    USE particle_attributes
+    USE arrays_3d,                                                             &
+        ONLY:  pt, u, v, w, zu, zw
+
+    USE control_parameters,                                                    &
+        ONLY:  atmos_ocean_sign, u_gtrans, v_gtrans, dz
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point_s
+
+    USE dvrp_variables,                                                        &
+        ONLY:  color_interval, dvrp_colortable_entries_prt, dvrpsize_interval, &
+               particle_color, particle_dvrpsize
+
+    USE grid_variables,                                                        &
+        ONLY:  ddx, dx, ddy, dy
+
+    USE indices,                                                               &
+        ONLY:  ngp_2dh, nxl, nxr, nyn, nys, nzb, nzt
+
+    USE kinds
+
+    USE particle_attributes,                                                   &
+        ONLY:  number_of_particles, offset_ocean_nzt, particles
+
     USE pegrid
-    USE statistics
+
+    USE statistics,                                                            &
+        ONLY:  sums, sums_l
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k, n
-    REAL    ::  aa, absuv, bb, cc, dd, gg, height, pt_int, pt_int_l, pt_int_u, &
-                u_int, u_int_l, u_int_u, v_int, v_int_l, v_int_u, w_int,       &
-                w_int_l, w_int_u, x, y
-
+    INTEGER(iwp) ::  i        !:
+    INTEGER(iwp) ::  j        !:
+    INTEGER(iwp) ::  k        !:
+    INTEGER(iwp) ::  n        !:
+
+    REAL(wp)    ::  aa        !:
+    REAL(wp)    ::  absuv     !:
+    REAL(wp)    ::  bb        !:
+    REAL(wp)    ::  cc        !:
+    REAL(wp)    ::  dd        !:
+    REAL(wp)    ::  gg        !:
+    REAL(wp)    ::  height    !:
+    REAL(wp)    ::  pt_int    !:
+    REAL(wp)    ::  pt_int_l  !:
+    REAL(wp)    ::  pt_int_u  !:
+    REAL(wp)    ::  u_int     !:
+    REAL(wp)    ::  u_int_l   !:
+    REAL(wp)    ::  u_int_u   !:
+    REAL(wp)    ::  v_int     !:
+    REAL(wp)    ::  v_int_l   !:
+    REAL(wp)    ::  v_int_u   !:
+    REAL(wp)    ::  w_int     !:
+    REAL(wp)    ::  w_int_l   !:
+    REAL(wp)    ::  w_int_u   !:
+    REAL(wp)    ::  x         !:
+    REAL(wp)    ::  y         !:
 
     CALL cpu_log( log_point_s(49), 'lpm_set_attributes', 'start' )
Index: /palm/trunk/SOURCE/lpm_sort_arrays.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_sort_arrays.f90	(revision 1319)
+++ /palm/trunk/SOURCE/lpm_sort_arrays.f90	(revision 1320)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! ------------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -41,16 +45,31 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE control_parameters
-    USE cpulog
-    USE grid_variables
-    USE indices
-    USE particle_attributes
+    USE control_parameters,                                                     &
+        ONLY:  message_string, dz
+
+    USE cpulog,                                                                 &
+        ONLY:  cpu_log, log_point_s
+
+    USE grid_variables,                                                         &
+        ONLY:  ddx, dx, ddy, dy
+
+    USE indices,                                                                &
+        ONLY:  nxl, nxr, nyn, nys, nzb, nzt
+
+    USE kinds
+
+    USE particle_attributes,                                                    &
+        ONLY:  number_of_particles, offset_ocean_nzt, part_1, part_2, particles,&
+               particle_type, prt_count, prt_start_index, sort_count
 
     IMPLICIT NONE
 
-    INTEGER ::  i, ilow, j, k, n
+    INTEGER(iwp) ::  i                                            !:
+    INTEGER(iwp) ::  ilow                                         !:
+    INTEGER(iwp) ::  j                                            !:
+    INTEGER(iwp) ::  k                                            !:
+    INTEGER(iwp) ::  n                                            !:
 
-    TYPE(particle_type), DIMENSION(:), POINTER ::  particles_temp
+    TYPE(particle_type), DIMENSION(:), POINTER ::  particles_temp !:
 
 
Index: /palm/trunk/SOURCE/lpm_write_exchange_statistics.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_write_exchange_statistics.f90	(revision 1319)
+++ /palm/trunk/SOURCE/lpm_write_exchange_statistics.f90	(revision 1320)
@@ -20,5 +20,7 @@
 ! Current revisions:
 ! ------------------
-! 
+! ONLY-attribute added to USE-statements,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -42,6 +44,13 @@
 !------------------------------------------------------------------------------!
 
-    USE control_parameters
-    USE particle_attributes
+    USE control_parameters,                                                     &
+        ONLY:  current_timestep_number, dt_3d, simulated_time
+
+    USE particle_attributes,                                                    &
+        ONLY:  maximum_number_of_particles, number_of_particles, trlp_count_sum,&
+               trlp_count_recv_sum, trnp_count_sum, trnp_count_recv_sum,        &
+               trrp_count_sum, trrp_count_recv_sum, trsp_count_sum,             &
+               trsp_count_recv_sum
+
     USE pegrid
 
Index: /palm/trunk/SOURCE/lpm_write_restart_file.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_write_restart_file.f90	(revision 1319)
+++ /palm/trunk/SOURCE/lpm_write_restart_file.f90	(revision 1320)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! ------------------
-! 
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -38,12 +42,24 @@
 !------------------------------------------------------------------------------!
 
-    USE control_parameters
-    USE particle_attributes
+    USE control_parameters,                                                    &
+        ONLY:  io_blocks, io_group
+
+    USE kinds
+
+    USE particle_attributes,                                                   &
+        ONLY:  bc_par_b, bc_par_lr, bc_par_ns, bc_par_t, initial_particles,    &
+        maximum_number_of_particles,  maximum_number_of_tails,                 &
+        maximum_number_of_tailpoints, number_of_initial_particles,             &
+        number_of_particles, number_of_particle_groups, number_of_tails,       &
+        particles, particle_groups, particle_tail_coordinates, prt_count,      &
+        prt_start_index, time_prel, time_write_particle_data,                  &
+        uniform_particles, use_particle_tails
+
     USE pegrid
 
     IMPLICIT NONE
 
-    CHARACTER (LEN=10) ::  particle_binary_version
-    INTEGER ::  i
+    CHARACTER (LEN=10) ::  particle_binary_version   !:
+    INTEGER(iwp) ::  i                               !:
 
 !
